/*
    Drools5 Integration Helper
    Copyright (C) 2009  Mathieu Boretti mathieu.boretti@gmail.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */
package org.boretti.drools.integration.drools5;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import org.apache.maven.plugin.MojoExecutionException;
import org.apache.maven.plugin.logging.Log;
import org.objectweb.asm.ClassReader;
import org.objectweb.asm.ClassWriter;

/**
 * @author mbo
 * @since 1.0.0
 *
 */
class DroolsClassProcessor {
	private DroolsClassProcessor() {}
	
	public static void ClassProcessor(Log logger,File src)
	throws MojoExecutionException {
		if (src==null) return;
		try {
			FileInputStream fis = new FileInputStream(src);
			ClassReader cr = new ClassReader(fis);
			ClassWriter cw = new ClassWriter(cr,0); // 0 ???
			DroolsClassVisitor dcv = new DroolsClassVisitor(logger,cw);
			cr.accept(dcv, 0); // 0 ???
			byte clazz[] = cw.toByteArray();
			fis.close();
			if (dcv.isNeedChange()) {
				logger.info("File "+src+" must be rewritten.");
				fis.close();
				FileOutputStream fos = new FileOutputStream(src);
				fos.write(clazz);
			}
		} catch (FileNotFoundException e) {
			logger.error(""+e.getMessage(),e);
			throw new MojoExecutionException(""+e.getMessage(),e);
		} catch (IOException e) {
			logger.error(""+e.getMessage(),e);
			throw new MojoExecutionException(""+e.getMessage(),e);
		}
	}
}
